package samples.oo.classes;

import static java.lang.System.out;

/*
    Constructors

 */


public class CtorAndThis {

    public static void main(String[] args) {
        new CtorAndThis().program();
    }

    void program() {
        // If no ctor have to assign each instance variable

        // Use ctor
        Player p1 = new Player("Olle", 5);  // Instantiation expression
        Player p2 = new Player("Fia", 7);

        out.println(p1.getName());
        out.println(p2.getName());

        Player p3 = new Player(p1);
        out.println(p1 != p3);
        out.println(p3.getName().equals(p1.getName()));
    }

    class Player {
        final String name;
        int points;

        Player(String name, int points) {  // Constructor
            this.name = name;
            this.points = points;
        }

        Player (String name){     // Overloaded contructor
            this.name = name;
            this.points = 0;
        }

        /*Player(String name) {   // Overloaded, using this
            this(name, 0);        // this() is constructor
        }*/

        Player(Player other) {
            this(other.name, other.points);
        }

        String getName() {
            return name;      // Same as this.name
        }
    }

}
