package pong.model;


import static pong.model.Pong.HEIGHT;

/**
 * A Paddle for the Pong game
 */
public class Paddle extends AbstractMovablePongObject {

    private final String discriminator;

    public Paddle(double x, double y, double width, double height, String discriminator) {
        super(x, y, width, height, 0, 0);
        this.discriminator = discriminator;
    }

    public Paddle(double x, double y, double width, double height) {
        this(x, y, width, height, "");
    }

    @Override  // TODO Not fool proof!
    public void move() {
        if (0 < getMinY() && getMaxY() < HEIGHT) {
            setY(getMinY() + getDy());
        } else {
            setY(getMinY() - 2 * getDy()); // Move into accepted range
            super.setDy(0);
        }
    }

    @Override
    public String discriminator() {
        return discriminator;
    }
}
