package pong.test;

import javafx.animation.AnimationTimer;
import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.image.Image;
import javafx.scene.layout.BorderPane;
import javafx.stage.Stage;
import pong.model.Ball;
import pong.service.ImageService;


/*
   This is technical tests, GUI, images, sounds etc.
 */

public class TestFX extends Application {

    Ball ball;

    private void update() {
        ball.move();
    }

    public void render() {
        gc.clearRect(0, 0, 400, 400);
        Image i = ImageService.getImage("../assets/img/cool/", "ball.png", ball.getWidth(), ball.getHeight());
        gc.drawImage(i, ball.getMinX(), ball.getMinY());

    }


    public void init() {
        ball = new Ball();
    }


    private GraphicsContext gc;

    @Override
    public void start(Stage primaryStage) throws Exception {
        BorderPane root = new BorderPane();
        Canvas canvas = new Canvas(400, 400);
        root.setCenter(canvas);
        gc = canvas.getGraphicsContext2D();
        AnimationTimer timer = new AnimationTimer() {
            // Param not used
            public void handle(long currentNanoTime) {
                update();
                render();
            }
        };
        Scene scene = new Scene(root);
        primaryStage.setScene(scene);
        primaryStage.show();
        timer.start();
    }


}
